local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioTriggers = import('/lua/scenariotriggers.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')

playerTable = {
	['player1'] = {
		ai = true,
		army = 'ARMY_1',
		difficulty = 0,
		displayName = 'Player 1',
		evolve = false,
		form = 1,
		hasChosen = false,
		inMenu = false,
		isPlaying = false,
		race = nil,
		subform = 0,
		unit = nil,
	},
	['player2'] = {
		ai = true,
		army = 'ARMY_2',
		difficulty = 0,
		displayName = 'Player 2',
		evolve = false,
		form = 1,
		hasChosen = false,
		inMenu = false,
		isPlaying = false,
		race = nil,
		subform = 0,
		unit = nil,
	},
	['player3'] = {
		ai = true,
		army = 'ARMY_3',
		difficulty = 0,
		displayName = 'Player 3',
		evolve = false,
		form = 1,
		hasChosen = false,
		inMenu = false,
		isPlaying = false,
		race = nil,
		subform = 0,
		unit = nil,
	},
	['player4'] = {
		ai = true,
		army = 'ARMY_4',
		difficulty = 0,
		displayName = 'Player 4',
		evolve = false,
		form = 1,
		hasChosen = false,
		inMenu = false,
		isPlaying = false,
		race = nil,
		subform = 0,
		unit = nil,
	},
	['enemy'] = {
		ai = true,
		army = 'ARMY_12',
		displayName = 'Enemy Swarm',
		isPlaying = false,
		race = 'Everything!'
	},
}

local armyTable = {
	['ARMY_1'] = 'player1',
	['ARMY_2'] = 'player2',
	['ARMY_3'] = 'player3',
	['ARMY_4'] = 'player4',
	['ARMY_12'] = 'enemy',
}

local difficultyTable = {
	[1] = 'Easy',
	[2] = 'Medium',
	[3] = 'Hard',
	[4] = 'Tunafish',
}

local raceTable = {
	[1] = 'UEF',
	[2] = 'Cybran',
	[3] = 'Aeon',
	[4] = 'Seraphim',
}

local heroTable = {
	['UEF'] = {
		['Form1'] = {
			[1] = {
				['hp'] = 1000,
				['id'] = 'del0204',
				['name'] = 'Gatling Bot',
			},
			[2] = {
				['hp'] = 1200,
				['id'] = 'uel0202',
				['name'] = 'Heavy Tank',
			},
		},
		['Form2'] = {
			[1] = {
				['damageRadius'] = {
					[1] = 2,
				},
				['hp'] = 6000,
				['id'] = 'xel0305',
				['name'] = 'Siege Bot',
			},
			[2] = {
				['hp'] = 4500,
				['id'] = 'uel0303',
				['name'] = 'Heavy Assault Bot',
			},
		},
		['Form3'] = {
			[1] = {
				['hp'] = 12000,
				['id'] = 'uel0401',
				['name'] = 'Fatboy',
			},
		},
	},
	['Cybran'] = {
		['Form1'] = {
			[1] = {
				['hp'] = 800,
				['id'] = 'drl0204',
				['name'] = 'Rocket Bot',
			},
			[2] = {
				['hp'] = 900,
				['id'] = 'url0202',
				['name'] = 'Heavy Tank',
			},
		},
		['Form2'] = {
			[1] = {
				['hp'] = 7000,
				['id'] = 'xrl0305',
				['name'] = 'Armored Assault Bot',
			},
			[2] = {
				['hp'] = 4000,
				['id'] = 'xrl0305',
				['name'] = 'Siege Assault Bot',
			},
		},
		['Form3'] = {
			[1] = {
				['hp'] = 14000,
				['id'] = 'xrl0403',
				['name'] = 'Experimental Megabot',
			},
			[2] = {
				['hp'] = 10000,
				['id'] = 'url0402',
				['name'] = 'Experimental Spiderbot',
			},
		},
	},
	['Aeon'] = {
		['Form1'] = {
			[1] = {
				['hp'] = 1000,
				['id'] = 'xal0203',
				['name'] = 'Assault Tank',
			},
			[2] = {
				['damageRadius'] = {
					[1] = 1,
				},
				['hp'] = 900,
				['id'] = 'ual0202',
				['name'] = 'Heavy Tank',
			},
		},
		['Form2'] = {
			[1] = {
				['hp'] = 4000,
				['id'] = 'ual0303',
				['name'] = 'Heavy Assault Bot',
			},
			[2] = {
				['hp'] = 2000,
				['id'] = 'xal0305',
				['name'] = 'Sniper Bot',
				['rateOfFire'] = {
					[1] = 0.5,
				},
			},
		},
		['Form3'] = {
			[1] = {
				['hp'] = 9000,
				['id'] = 'ual0401',
				['name'] = 'Experimental Assault Bot',
			},
		},
	},
	['Seraphim'] = {
		['Form1'] = {
			[1] = {
				['hp'] = 900,
				['id'] = 'xsl0202',
				['name'] = 'Assault Bot',
			},
			[2] = {
				['damageRadius'] = {
					[1] = 1,
				},
				['hp'] = 1100,
				['id'] = 'xsl0203',
				['name'] = 'Hover Tank',
			},
		},
		['Form2'] = {
			[1] = {
				['hp'] = 5500,
				['id'] = 'xsl0303',
				['name'] = 'Siege Tank',
			},
			[2] = {
				['hp'] = 2000,
				['id'] = 'xsl0305',
				['name'] = 'Sniper Bot',
			},
		},
		['Form3'] = {
			[1] = {
				['hp'] = 11000,
				['id'] = 'xsl0401',
				['name'] = 'Experimental Assault Bot',
			},
		},
	},
}

local waveTable = {
	[1] = {
		hp = 50,
		unit = 'url0101',#dps=0=0
		number = 2,
	},
	[2] = {
		hp = 63,
		unit = 'ual0101',#dps=1(2)=1
		number = 2,
	},
	[3] = {
		damage = {
			[1] = 4,
		},
		hp = 78,
		unit = 'uel0101',#dps=1(2)=2
		number = 2,
	},
	[4] = {
		damage = {
			[1] = 0.9,
		},
		hp = 98,
		unit = 'xsl0101',#dps=13(4)=3
		number = 2,
	},
	[5] = {
		damage = {
			[1] = 1.3,
		},
		hp = 122,
		unit = 'ual0106',#dps=21(7)=4
		number = 2,
	},
	[6] = {
		damage = {
			[1] = 1.7,
		},
		hp = 153,
		unit = 'url0106',#dps=21(7)=5
		number = 2,
	},
	[7] = {
		damage = {
			[1] = 2,
		},
		hp = 190,
		unit = 'uel0106',#dps=23(7)=6
		number = 2,
	},
	[8] = {
		damage = {
			[1] = 7,
		},
		hp = 238,
		unit = 'uel0201',#dps=24(24)=7
		number = 2,
	},
	[9] = {
		damage = {
			[1] = 10.25,
		},
		hp = 298,
		unit = 'xsl0201',#dps=25(32)=8
		number = 2,
	},
	[10] = {
		damage = {
			[1] = 13.3,
		},
		hp = 372,
		unit = 'ual0201',#dps=27(40)=9
		number = 2,
	},
	[11] = {
		damage = {
			[1] = 3,
		},
		hp = 466,
		unit = 'url0107',#dps=27(8)=10
		number = 2,
	},
}

local difficulty = 0
local wave = 1

function OnPopulate()
	InitializeBlueprintChanges()
	ScenarioUtils.InitializeArmies()
	InitializeArmyTable()
	InitializeAlliances()
end
   
function OnStart(self)
	FreezeCommanders()
	InitializeTriggers()
	OpenMenuDifficulty()
end


-- Custom functions start here


function InitializeBlueprintChanges()
	-- Faction
	for a, b in heroTable do
		-- Form
		for c, d in b do
			-- Number
			for e, f in d do
				local bp = GetUnitBlueprintByName(f.id)
				
				if f.hp then
					bp.Defense.Health = f.hp
					bp.Defense.MaxHealth = f.hp
				end
				
				for i = 1, table.getn(bp.Weapon) do
					if f.damage[i] then
						bp.Weapon[i].Damage = f.damage[i]
					end
					
					if f.damageRadius[i] then
						bp.Weapon[i].DamageRadius = f.damageRadius[i]
					end
					
					if f.rateOfFire[i] then
						bp.Weapon[i].RateOfFire = f.rateOfFire[i]
					end
				end
			end
		end
	end
	
	local commanders = {'ual0001', 'uel0001', 'url0001', 'xsl0001'}
	for k, v in commanders do
		local bp = GetUnitBlueprintByName(v)
		bp.Defense.Health = 10000
		bp.Defense.MaxHealth = 10000
		bp.Defense.RegenRate = 1
	end
end

function InitializeArmyTable()
	local tblArmy = ListArmies()
	for k, v in tblArmy do
		if ArmyBrains[k].Nickname and ArmyBrains[k].Nickname != 'civilian' then
			playerTable[armyTable[v]].displayName = ArmyBrains[k].Nickname
		end
		playerTable[armyTable[v]].isPlaying = true
		playerTable[armyTable[v]].ai = not ScenarioInfo.ArmySetup[v].Human
	end
end

function InitializeAlliances()
	local tblArmy = ListArmies()
	for index,army in tblArmy do
		for index2,army2 in tblArmy do
			if army != army2 then
				if army == 'ARMY_12' or army2 == 'ARMY_12' then
					SetAlliance(army, army2, 'Enemy')
				else
					SetAlliance(army, army2, 'Ally')
				end
			end
		end
	end
end

function InitializeTriggers()
	--CreateAreaTrigger(callbackFunction, rectangle, category, onceOnly, invert, aiBrain, number, requireBuilt)
	-- Gets a list of all entities within a defined rectangle.
	--  callbackFunction = the entities that match the category will be placed into the function
	--  rectangle = a map area or rectangle
	--  category = Like EDF or LAND or MOBILE and such. Listed in a unit's bp. Make sure you have categories.WHATEVER
	--  onceOnly = will not run again after it runs for the first time
	--  invert = runs when units are NOT in the area
	--  aiBrain = the brain of whatever army. Has to match the units it is testing for
	--  number = false makes it kick out as soon as one of the entities is in there, returning that entity to the callbackFunction.  Else it builds them into a table of entities and sends them to the callbackFunction
	--  requireBuilt = requires the unit being tested to be fully constructed before being accepted as the correct entity
	local tblArmy = ListArmies()
	for k, v in tblArmy do
		if v != 'ARMY_12' then
			local triggerHealLeft = ScenarioTriggers.CreateAreaTrigger(Heal, 'areaHealLeft', categories.MOBILE, false, false, GetArmyBrain(v), 1, true)
			local triggerHealRight = ScenarioTriggers.CreateAreaTrigger(Heal, 'areaHealRight', categories.MOBILE, false, false, GetArmyBrain(v), 1, true)
			local triggerChangeTop = ScenarioTriggers.CreateAreaTrigger(Change, 'areaChangeTop', categories.MOBILE, false, false, GetArmyBrain(v), false, true)
			local triggerChangeBot = ScenarioTriggers.CreateAreaTrigger(Change, 'areaChangeBot', categories.MOBILE, false, false, GetArmyBrain(v), false, true)
		end
	end
end

function Heal(units)
	for k, v in units do
		v:SetHealth(v, v:GetHealth() + math.floor((v:GetMaxHealth() / 100) + 0.5))
		#v:SetShieldRatio(v:GetShieldRatio() + 1)
	end
end

function Change(unit)
	local OpenMenuUnitPickThread = ForkThread(function(self)
		WaitSeconds(0.1)
		
		local player = playerTable[unit.owner]

		if (not player.inMenu) and (player.unit.VeteranLevel >= 10) and (heroTable[raceTable[player.race]]['Form' .. player.form + 1]) then
			player.inMenu = true
			
			local text = 'Pick an Evolved Unit'
			local buttons = {}
			
			
			for k, v in heroTable[raceTable[player.race]]['Form' .. player.form + 1] do
				table.insert(buttons, v.name)
			end
			
			table.insert(buttons, 'Cancel')
			
			if (armyTable[GetArmyByID(GetFocusArmy())] != unit.owner) then
				text = player.displayName .. ' is choosing an evolved unit.'
			end
			
			local dialogue = CreateDialogue(text, buttons)
			dialogue.OnButtonPressed = function(dialogue, button)
				if button.buttonID != table.getn(buttons) then
					playerNew = playerTable[armyTable[GetArmyByID(button.presser)]]
					playerNew.subform = button.buttonID
					playerNew.form = player.form + 1
					playerNew.evolve = true
				end
				
				dialogue:Destroy()
				SetOutOfMenuSoon(player)
			end
			
			if (armyTable[GetArmyByID(GetFocusArmy())] != unit.owner) then
				for k, v in buttons do
					dialogue:SetButtonDisabled(k, true)
				end
			end
		end
	end)
end

function SetOutOfMenuSoon(player)
	local SetOutOfMenuSoonThread = ForkThread(function(self)
		WaitSeconds(3)
		player.inMenu = false
	end)
end

function FreezeCommanders()
	local FreezeCommandersThread = ForkThread(function(self)
		WaitSeconds(6)
		local UnitsinRec = GetUnitsInRect(Rect(1, 1, 255, 255))
		
		for k, v in UnitsinRec do
			if EntityCategoryContains(categories.COMMAND, v) then
				#v.WarpInEffectThread = function(self) end
				IssueClearCommands({v})
		        #v:HideBone(0, true)
		        v:SetUnSelectable(true)
		        v:SetBusy(true)
		        v:SetBlockCommandQueue(true)
				v:SetImmobile(true)
				v:SetIsValidTarget(true)
				v:SetDoNotTarget(false)
				v:SetCanBeKilled(true)
				v:SetCapturable(false)
				v:SetReclaimable(false)
				v:AlterArmor('Normal', 1)
				for i = 1, v:GetWeaponCount() do
					v:GetWeapon(i):SetEnabled(false)
				end
				
				v:SetCustomName('Wave 1')
				v:SetMaxHealth(10000)
				v:SetHealth(v, 10000)
				v:SetRegenRate(1)
				
				playerTable[armyTable[GetArmyByID(v:GetArmy())]].protectedUnit = v
			end
		end
	end)
end

function OpenMenuDifficulty()
	local OpenMenuDifficultyThread = ForkThread(function(self)
		WaitSeconds(4)
		
		local text = 'Choose a Difficulty'
		local buttons = {'Easy', 'Medium', 'Hard', 'Tunafish'}
		local OnButtonPressed = function(dialogue, button)
			local player = playerTable[armyTable[GetArmyByID(button.presser)]]
			player.difficulty = button.buttonID
			
			local text = player.displayName .. ' has selected ' .. difficultyTable[player.difficulty]
			PrintText(text,20,'00FFa000',5,'center')
		end
		
		local dialogue = CreateDialogue(text, buttons)
		dialogue.OnButtonPressed = OnButtonPressed
		WaitForDifficulty(dialogue)
	end)
end

function GetArmyByID(id)
	local tblArmy = ListArmies()
	for k, v in tblArmy do
		if k == id then
			return v
		end
	end
end

function WaitForDifficulty(dialogue)
	local WaitForDifficultyThread = ForkThread(function(self)
		local stillWaiting = true
		local difficultyTotalTable = {}
		
		while stillWaiting do
			WaitSeconds(1)
			
			local playerAmount = 0
			local difficultyAmount = 0
			difficultyTotalTable = {}
			
			for k, v in playerTable do
				if v.isPlaying and v.ai == false then
					playerAmount = playerAmount + 1
					if v.difficulty > 0 then
						difficultyAmount = difficultyAmount + 1
						table.insert(difficultyTotalTable, v.difficulty)
					end
				end
			end
			
			if difficultyAmount == playerAmount then
				stillWaiting = false
				dialogue:Destroy()
			end
		end
		
		SetDifficulty(difficultyTotalTable)
		OpenMenuRace()
	end)
end

function SetDifficulty(difficultyTotalTable)
	local sum = 0
	
	for k, v in difficultyTotalTable do
		sum = sum + v
	end
	
	local average = sum / table.getn(difficultyTotalTable)
	
	average = math.floor(average + 0.5)
	
	difficulty = average
	
	local text = 'The difficulty has been averaged to ' .. difficultyTable[difficulty]
	PrintText(text,20,'00FFa000',5,'center')
end

function OpenMenuRace()
	local OpenMenuRaceThread = ForkThread(function(self)
		WaitSeconds(3)
		
		local text = 'Choose a Race'
		local buttons = {'UEF', 'Cybran', 'Aeon', 'Seraphim'}
		
		local dialogue = CreateDialogue(text, buttons)
		dialogue.OnButtonPressed = function(dialogue, button)
			local player = playerTable[armyTable[GetArmyByID(button.presser)]]
			player.race = button.buttonID
			
			local text = player.displayName .. ' has selected ' .. raceTable[player.race]
			PrintText(text,20,'00FFa000',5,'center')
		end
		WaitForRace(dialogue)
	end)
end

function WaitForRace(dialogue)
	local WaitForRaceThread = ForkThread(function(self)
		local stillWaiting = true
		
		for k, v in playerTable do
			if v.isPlaying and v.ai and not v.race then
				local num = Random(1, 4)
				v.race = num
				
				local text = v.displayName .. ' has selected ' .. raceTable[v.race]
				PrintText(text,20,'00FFa000',5,'center')
			end
		end
		
		while stillWaiting do
			WaitSeconds(1)
			
			local playerAmount = 0
			local raceAmount = 0
			
			for k, v in playerTable do
				if v.isPlaying then
					playerAmount = playerAmount + 1
					if v.race then
						raceAmount = raceAmount + 1
					end
				end
			end
			
			if raceAmount == playerAmount then
				stillWaiting = false
				dialogue:Destroy()
			end
		end
		
		OpenMenuUnitPick()
	end)
end

function OpenMenuUnitPick()
	local OpenMenuUnitPickThread = ForkThread(function(self)
		WaitSeconds(1)
		
		local text = 'Pick a Unit'
		local buttons = {}
				
		for k, v in heroTable[raceTable[playerTable[armyTable[GetArmyByID(GetFocusArmy())]].race]]['Form1'] do
			table.insert(buttons, v.name)
		end
		local OnButtonPressed = function(dialogue, button)
			local player = playerTable[armyTable[GetArmyByID(button.presser)]]
			player.subform = button.buttonID
			
			local text = player.displayName .. ' has selected ' .. heroTable[raceTable[player.race]]['Form1'][player.subform].name
			PrintText(text,20,'00FFa000',5,'center')
		end
		
		local currentPlayer = armyTable[GetArmyByID(GetFocusArmy())]
		
		local dialogue = CreateDialogue(text, buttons)
		dialogue.OnButtonPressed = OnButtonPressed
		WaitForUnitPick(dialogue)
	end)
end

function WaitForUnitPick(dialogue)
	local WaitForUnitPickThread = ForkThread(function(self)
		local stillWaiting = true
		
		for k, v in playerTable do
			if v.isPlaying and v.ai and v.subform then
				local num = Random(1, table.getn(heroTable[raceTable[v.race]]['Form1']))
				v.subform = num
				
				local text = v.displayName .. ' has selected ' .. heroTable[raceTable[v.race]]['Form1'][v.subform]
				PrintText(text,20,'00FFa000',5,'center')
			end
		end
		
		while stillWaiting do
			WaitSeconds(1)
			
			local playerAmount = 0
			local subformAmount = 0
			
			for k, v in playerTable do
				if v.isPlaying and v.subform then
					playerAmount = playerAmount + 1
					if v.subform > 0 then
						subformAmount = subformAmount + 1
					end
				end
			end
			
			if subformAmount == playerAmount then
				stillWaiting = false
				dialogue:Destroy()
			end
		end
		
		WaitSeconds(1)
		
		SpawnHeroes()
		
		WaitSeconds(3)
		
		SpawnEnemies()
	end)
end

function SpawnHeroes()
	for k, v in playerTable do
		if v.isPlaying and k != 'enemy' then
			local unitData = heroTable[raceTable[v.race]]['Form1'][v.subform]
			local bp = GetUnitBlueprintByName(unitData.id)
		
			local position = ScenarioUtils.MarkerToPosition(v.army)
			local unit = CreateUnitHPR(unitData.id, v.army, position[1], position[2], position[3], 0, 0, 0)
			
			v.unit = unit
			v.unit.owner = k
			v.unit:SetCustomName(v.displayName)
			
			unit:SetMaxHealth(unitData.hp)
			unit:SetHealth(unit, unitData.hp)
			
			for i = 1, unit:GetWeaponCount() do
				if unitData.rateOfFire[i] then
					unit:GetWeapon(i):ChangeRateOfFire(unitData.rateOfFire[i])
				end
			end
			
			CreateUnitWatcher(k)
		end
	end
end

function SpawnEnemies()
	local SpawnEnemiesThread = ForkThread(function(self)
		local SpawnLocation = {
			'areaSpawnTopLeft',
			'areaSpawnTopMid',
			'areaSpawnTopRight',
			'areaSpawnMidLeft',
			'areaSpawnMidRight',
			'areaSpawnBotLeft',
			'areaSpawnBotMid',
			'areaSpawnBotRight',
		}
		
		local playerAmount = 0
		for k, v in playerTable do
			if (v.isPlaying) and (v.difficulty) then
				playerAmount = playerAmount + 1
			end
		end
		
		while true do
			if wave > table.getn(waveTable) then
				wave = 1
			end
			
			local bp = GetUnitBlueprintByName(waveTable[wave].unit)
			
			for i = 1, table.getn(bp.Weapon) do
				if waveTable[wave].damage[i] then
					-- Store old data so that it can reset after making the units
					if not waveTable[wave].damageOld then waveTable[wave].damageOld = {} end
					waveTable[wave].damageOld[i] = bp.Weapon[i].Damage
					-- Sets damage
					bp.Weapon[i].Damage = waveTable[wave].damage[i] * (0.5 + (difficulty * 0.25))
				end
				
				if waveTable[wave].damageRadius[i] then
					-- Store old data so that it can reset after making the units
					if not waveTable[wave].damageRadiusOld then waveTable[wave].damageRadiusOld = {} end
					waveTable[wave].damageRadiusOld[i] = bp.Weapon[i].DamageRadius
					-- Sets damage radius
					bp.Weapon[i].DamageRadius = waveTable[wave].damageRadius[i]
				end
			end
			
			local text = 'Spawning Wave ' .. wave
			PrintText(text,20,'00FFa000',5,'center')
			
			for k, v in SpawnLocation do
				local areaName = ScenarioUtils.AreaToRect(v)
				local xMid = (areaName.x0 + areaName.x1) / 2
				local x = xMid
				local y = areaName.y0
				local unitCounter = 0
				local unitMax = waveTable[wave].number * playerAmount
				local unitGroup = {}
				
				while unitCounter <  unitMax do
					unitCounter = unitCounter + 1
					
					local unit = CreateUnitHPR(waveTable[wave].unit, 'ARMY_12', x, 64, y, 0, 0, 0)
					
					unit:SetMaxHealth(waveTable[wave].hp  * (0.5 + (difficulty * 0.25)))
					unit:SetHealth(unit, waveTable[wave].hp  * (0.5 + (difficulty * 0.25)))
					
					for i = 1, unit:GetWeaponCount() do
						if waveTable[wave].rateOfFire[i] then
							unit:GetWeapon(i):ChangeRateOfFire(waveTable[wave].rateOfFire[i])
						end
					end
					
					table.insert(unitGroup, unit)
					
					if math.mod(unitCounter, 2) == 1 then
						x = xMid - (x - xMid)
						x = x - 3
					else
						x = xMid + (xMid - x)
					end
					
					if x < areaName.x0 or x > areaName.x1 then
						x = xMid
						y = y + 3
					end
				end
				
				local brainArmy12 = GetArmyBrain('ARMY_12')
				local unitPlatoon = brainArmy12:MakePlatoon('','')
				brainArmy12:AssignUnitsToPlatoon(unitPlatoon, unitGroup, 'Attack', 'GrowthFormation')
				unitPlatoon:AggressiveMoveToLocation({128,64,128})
			end
			
			-- Resets damage so that it won't affect heroes if a hero is the same unit
			for i = 1, table.getn(bp.Weapon) do
				if waveTable[wave].damage[i] then
					bp.Weapon[i].Damage = waveTable[wave].damageOld[i]
				end
				
				if waveTable[wave].damageRadius[i] then
					bp.Weapon[i].DamageRadius = waveTable[wave].damageRadiusOld[i]
				end
			end
			
			WaitSeconds(60)
			
			wave = wave + 1
			
			local UnitsinRec = GetUnitsInRect(Rect(1, 1, 255, 255))
			for k, v in UnitsinRec do
				if EntityCategoryContains(categories.COMMAND, v) then
					v:SetMaxHealth(v:GetMaxHealth() + 500)
					v:SetHealth(v, v:GetHealth() + 500)
					v:SetRegenRate(wave)
					v:SetCustomName('Wave ' .. wave)
				end
			end
		end
	end)
end

function CreateUnitWatcher(owner)
	local WaitForChangeThread = ForkThread(function(self)
		local player = playerTable[owner]
		local lastForm = 1
		while player.isPlaying do
			if not player.unit:IsDead() then
				-- Displays that the form can be changed
				if lastForm == player.form then
					local level = player.unit.VeteranLevel
					if level >= 10 then
						if heroTable[raceTable[player.race]]['Form' .. player.form + 1] then
							local text = player.displayName .. ' can evolve their ' .. heroTable[raceTable[player.race]]['Form' .. player.form][player.subform].name
							PrintText(text,20,'00FFa000',5,'center')
							
							lastForm = lastForm + 1
						end
					end
				end
				
				if player.evolve then
					player.evolve = false
					
					local unitData = heroTable[raceTable[player.race]]['Form' .. player.form][player.subform]
					local bp = GetUnitBlueprintByName(unitData.id)
					
					local position = player.unit:GetPosition()
					local owner = player.unit.owner
					player.unit:Destroy()
					local unit = CreateUnitHPR(unitData.id, player.army, position.x, position.y, position.z, 0, 0, 0)
					
					player.unit = unit
					player.unit.owner = owner
					player.unit:SetCustomName(player.displayName)
					
					unit:SetMaxHealth(unitData.hp)
					unit:SetHealth(unit, unitData.hp)
					
					for i = 1, unit:GetWeaponCount() do
						if unitData.rateOfFire[i] then
							unit:GetWeapon(i):ChangeRateOfFire(unitData.rateOfFire[i])
						end
					end
					
					local text = player.displayName .. ' has changed into ' .. heroTable[raceTable[player.race]]['Form' .. player.form][player.subform].name
					PrintText(text,20,'00FFa000',5,'center')
				end
			else
				WaitSeconds(1)
				if player.unit:IsDead() then
					player.isPlaying = false
					local text = player.displayName .. ' has been killed'
					PrintText(text,20,'00FFa000',5,'center')
					
					WaitSeconds(3)
					GetArmyBrain(player.army):OnDefeat()
				end
			end
			
			if player.protectedUnit:IsDead() and player.isPlaying then
				player.isPlaying = false
				local text = player.displayName .. ' has lost the one the one that they were supposed to protect'
				PrintText(text,20,'00FFa000',5,'center')
				
				WaitSeconds(3)
				GetArmyBrain(player.army):OnDefeat()
			end
			
			WaitSeconds(2)
		end
	end)
end